=== modified file '.bzrignore'
--- .bzrignore	2009-04-01 14:40:05 +0000
+++ .bzrignore	2009-02-10 01:57:06 +0000
@@ -6,4 +6,3 @@
 build
 *.log
 _trial_temp
-loggerhead-memprofile

=== modified file 'NEWS'
--- NEWS	2009-05-27 15:57:20 +0000
+++ NEWS	2009-03-04 21:02:14 +0000
@@ -4,16 +4,13 @@
 dev [future]
 ---------------
 
-    - Make sure that binary files aren't annotated. (Martin Albisetti,
-      #258848)
-
     - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. Addresses bug #240577. (Jonathan Lange)
+      to branch them. (Jonathan Lange)
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Added optional syntax highlighting to annotate view using
+    - Added syntax highlighting to annotate view using
       python-pygments.  Partially addresses bug #306631. (Peter Bui)
 
     - Convert newlines in commit messages to HTML line breaks for
@@ -21,102 +18,30 @@
       Bui)
 
     - serve-branches now errors if run behind a proxy without
-      paste.deploy installed. (Michael Hudson)
+      paste.deploy installed.
 
     - Loggerhead should now handle file and directory names that need
       URL escaping without crashing.
 
     - The start-loggerhead script properly sets the wsgi.url_scheme
-      from the server.webpath option. (neror, #260547)
+      from the server.webpath option. (neror)
 
     - The revision page defaults to unified style again, and can
-      convert to a side-by-side view using JavaScript. (Michael Hudson)
-
-    - Clean up and improve performance of the annotate view. (Michael
-      Hudson)
-
-    - Finish converting JavaScript from MooTools to YUI 3. (Michael
-      Hudson)
-
-    - Improve compatibility with IE 6. (Michael Hudson)
+      convert to a side-by-side view using Javascript.
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Clip long lines in side-by-side diff view. (Michael Hudson,
-      #334837)
-
     - The user-confusing "next" and "previous" links now read "older"
-      and "newer" respectively. (Michael Hudson, #297930)
-
-    - The annotate view now contains line number anchors. (Michael
-      Hudson)
-
-    - Fix inventory pages using "//" in links. (Michael Hudson, #329668)
-
-    - Fix problems viewing files and directories containing spaces and
-      other funny characters. (Peter Bui)
+      and "newer" respectively.
+
+    - The annotate view now contains line number anchors.
+
+    - The annotate view does syntax highlighting using the "pygments"
+      library.  (Peter Bui)
 
     - Changelog messages are now displayed with newlines preserved.
-      (Peter Bui, #273688)
-
-    - Offer a link to see the full file diffs for a file path. (Michael
-      Hudson, #333797)
-
-    - Fix annotate error caused by Pygments stripping trailing
-      whitespace. (Michael Hudson, #338762)
-
-    - Loggerhead can be installed as a Bazaar plugin and run by
-      'bzr serve --http'. (Martin Pool)
-
-    - Load parts of the changelog and revision pages via XMLHttpRequest
-      to improve performance. This adds a dependency on simplejson or
-      json. Partially addresses bug #253950. (Michael Hudson)
-
-    - Various improvements to the animation JavaScript. (Michael Hudson)
-
-    - Fix HTML content of source files being displayed unescaped when
-      Pygments was unavailable. (Michael Hudson, #344970)
-
-    - Fix serve-branches's path argument. (Michael Hudson, #353230)
-
-    - serve-branches now has an option, --use-cdn, to load YUI from
-      Yahoo!'s CDN. (Matt Nordhoff)
-
-    - Fix certain race conditions for loading bzr-search. (Robert
-      Collins, #334250)
-
-    - Fix errors when using serve-branches --log-folder or --user-dirs.
-      (It was calling config.get_option() incorrectly.) (Matt Nordhoff,
-      bug #361238)
-
-    - Move some caching from RAM to the disk, and other caching and
-      memory usage improvements. (Michael Hudson)
-
-    - Add a --cache-dir option to serve-branches to choose where to
-      place the SQL cache, and only create one temporary SQL dir per
-      process. (Matt Nordhoff, #358322)
-
-    - Replace homebrew memory profiling code with Dozer. (Paul Hummer)
-
-    - Use the branch's public_branch as the default suggested URL to
-      branch from (Matt Nordhoff, #369767)
-
-    - Fix a file descriptor leak (Matt Nordhoff, #370845)
-
-    - Use transport API internally, so it is possible to specify a remote 
-      URL to serve-branches. (Jelmer Vernooij, #371787)
-
-    - Fix internal server errors when using start-loggerhead. (Matt
-      Nordhoff, #375948)
-
-    - Fix annotating non-UTF-8 files when Pygments is disabled. (Matt
-      Nordhoff, #376957)
-
-    - Fix 'bzr serve --http' errors. (Matt Nordhoff, #377551)
-
-    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
-      #380026)
+      (Peter Bui)
 
 1.10 [22Dec2008]
 ---------------

=== modified file '__init__.py'
--- __init__.py	2009-05-17 13:03:04 +0000
+++ __init__.py	2009-03-10 01:01:04 +0000
@@ -36,7 +36,7 @@
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0), (1, 15, 0)])
+    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0)])
 
     # TODO: This should provide a new type of server that can be used by bzr
     # serve, maybe through a registry, rather than overriding the command.  Though
@@ -71,24 +71,17 @@
                 import os.path, sys
                 sys.path.append(os.path.dirname(__file__))
 
-                from bzrlib.transport import get_transport
-                from loggerhead.apps.transport import BranchesFromTransportRoot
-                from loggerhead.config import LoggerheadConfig
+                from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
                 from paste.httpexceptions import HTTPExceptionHandler
                 from paste.httpserver import serve
-                path = kw.get('directory', '.')
+                a = HTTPExceptionHandler(BranchesFromFileSystemRoot('.'))
                 port = kw.get('port', DEFAULT_PORT)
                 # port might be an int already...
                 if isinstance(port, basestring) and ':' in port:
                     host, port = port.split(':')
                 else:
                     host = '0.0.0.0'
-                argv = ['--host', host, '--port', str(port), path]
-                config = LoggerheadConfig(argv)
-                transport = get_transport(path)
-                app = BranchesFromTransportRoot(transport, config)
-                app = HTTPExceptionHandler(app)
-                serve(app, host=host, port=port)
+                serve(a, host=host, port=port)
             else:
                 super(cmd_serve, self).run(*args, **kw)
 

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-05-27 16:21:06 +0000
+++ loggerhead/apps/branch.py	2009-03-17 00:02:21 +0000
@@ -31,38 +31,33 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False):
+                 served_url=_DEFAULT):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
         self.branch_link = branch_link  # Currently only used in Launchpad
         self.log = logging.getLogger('loggerhead.%s' % friendly_name)
         if graph_cache is None:
-            graph_cache = bzrlib.lru_cache.LRUCache(10)
+            graph_cache = bzrlib.lru_cache.LRUCache()
         self.graph_cache = graph_cache
         self.is_root = is_root
         self.served_url = served_url
-        self.use_cdn = use_cdn
 
     def get_history(self):
-        file_cache = None
-        revinfo_disk_cache = None
+        _history = History(self.branch, self.graph_cache)
         cache_path = self._config.get('cachepath', None)
         if cache_path is not None:
             # Only import the cache if we're going to use it.
             # This makes sqlite optional
             try:
-                from loggerhead.changecache import (
-                    FileChangeCache, RevInfoDiskCache)
+                from loggerhead.changecache import FileChangeCache
             except ImportError:
                 self.log.debug("Couldn't load python-sqlite,"
                                " continuing without using a cache")
             else:
-                file_cache = FileChangeCache(cache_path)
-                revinfo_disk_cache = RevInfoDiskCache(cache_path)
-        return History(
-            self.branch, self.graph_cache, file_cache=file_cache,
-            revinfo_disk_cache=revinfo_disk_cache, cache_key=self.friendly_name)
+                _history.use_file_cache(
+                    FileChangeCache(_history, cache_path))
+        return _history
 
     def url(self, *args, **kw):
         if isinstance(args[0], list):
@@ -84,13 +79,6 @@
     def static_url(self, path):
         return self._static_url_base + path
 
-    def yui_url(self, path):
-        if self.use_cdn:
-            base = 'http://yui.yahooapis.com/3.0.0pr2/build/'
-        else:
-            base = self.static_url('/static/javascript/yui/build/')
-        return base + path
-
     controllers_dict = {
         '+filediff': FileDiffUI,
         '+revlog': RevLogUI,
@@ -109,7 +97,7 @@
         change = h.get_changes([h.last_revid])[0]
         return change.date
 
-    def public_branch_url(self):
+    def branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
     def app(self, environ, start_response):
@@ -119,16 +107,7 @@
             self._static_url_base = self._url_base
         self._environ = environ
         if self.served_url is _DEFAULT:
-            public_branch = self.public_branch_url()
-            if public_branch is not None:
-                self.served_url = public_branch
-            else:
-                # Loggerhead only supports serving .bzr/ on local branches, so
-                # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
-                    self.served_url = self.url([])
-                else:
-                    self.served_url = None
+            self.served_url = self.url([])
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
+++ loggerhead/apps/config.py	2008-12-15 21:23:24 +0000
@@ -108,17 +108,20 @@
                 friendly_name = history.get_config().get_nickname()
                 if friendly_name is None:
                     friendly_name = view_name
-            branch_url = self._get_branch_url(view, view_config, view_name)
-            description = self._get_description(view, view_config, history)
             self.view_data_by_name[view_name] = {
                 'branch_path': folder,
-                'config': view_config,
-                'description': description,
+                'args': (view_name, view_config, self.graph_cache),
+                'description': self._get_description(view,
+                                                     view_config,
+                                                     history),
+                '_src_folder': folder,
+                '_view_config': view_config,
                 'friendly_name': friendly_name,
-                'graph_cache': self.graph_cache,
                 'name': view_name,
-                'served_url': branch_url,
                 }
+            branch_url = self._get_branch_url(view, view_config, view_name)
+            if branch_url is not None:
+                self.view_data_by_name[view_name]['branch_url'] = branch_url
             self.view_names.append(view_name)
         finally:
             b.unlock()
@@ -129,13 +132,12 @@
             return None
         view_data = view_data.copy()
         branch_path = view_data.pop('branch_path')
-        description = view_data.pop('description')
-        name = view_data.pop('name')
+        args = view_data.pop('args')
         b = bzrlib.branch.Branch.open(branch_path)
         b.lock_read()
-        view = BranchWSGIApp(b, **view_data)
-        view.description = description
-        view.name = name
+        view = BranchWSGIApp(b, *args)
+        for k in view_data:
+            setattr(view, k, view_data[k])
         return view
 
     def call(self, environ, start_response):

=== renamed file 'loggerhead/apps/transport.py' => 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/transport.py	2009-05-25 01:03:25 +0000
+++ loggerhead/apps/filesystem.py	2009-03-31 19:31:45 +0000
@@ -1,6 +1,8 @@
-"""Serve branches at urls that mimic a transport's file system layout."""
-
-from bzrlib import branch, errors, lru_cache, urlutils
+"""Serve branches at urls that mimic the file system layout."""
+
+import os
+
+from bzrlib import branch, errors, lru_cache
 
 from paste.request import path_info_pop
 from paste import httpexceptions
@@ -12,17 +14,17 @@
 from loggerhead.controllers.directory_ui import DirectoryUI
 
 
-class BranchesFromTransportServer(object):
+class BranchesFromFileSystemServer(object):
 
-    def __init__(self, transport, root, name=None):
-        self.transport = transport
+    def __init__(self, path, root, name=None):
+        self.path = path
         self.root = root
         self.name = name
-        self._config = root._config
+        self._config = LoggerheadConfig()
 
     def app_for_branch(self, branch):
         if not self.name:
-            name = branch._get_nick(local=True)
+            name = branch.get_config().get_nickname()
             is_root = True
         else:
             name = self.name
@@ -30,8 +32,7 @@
         branch_app = BranchWSGIApp(
             branch, name,
             {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache, is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'))
+            self.root.graph_cache, is_root=is_root)
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -45,33 +46,32 @@
             else:
                 name = '/'
             return DirectoryUI(environ['loggerhead.static.url'],
-                               self.transport,
+                               self.path,
                                name)
         else:
-            new_transport = self.transport.clone(segment)
+            new_path = os.path.join(self.path, segment)
             if self.name:
-                new_name = urlutils.join(self.name, segment)
+                new_name = os.path.join(self.name, segment)
             else:
                 new_name = '/' + segment
-            return BranchesFromTransportServer(new_transport, self.root, new_name)
+            return BranchesFromFileSystemServer(new_path, self.root, new_name)
 
     def __call__(self, environ, start_response):
+        if not os.path.isdir(self.path):
+            raise httpexceptions.HTTPNotFound()
         try:
-            b = branch.Branch.open_from_transport(self.transport)
+            b = branch.Branch.open(self.path)
         except errors.NotBranchError:
-            if not self.transport.listable() or not self.transport.has('.'):
-                raise httpexceptions.HTTPNotFound()
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
             return self.app_for_branch(b)(environ, start_response)
 
 
-class BranchesFromTransportRoot(object):
+class BranchesFromFileSystemRoot(object):
 
-    def __init__(self, transport, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
-        self._config = config
+    def __init__(self, folder):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
@@ -82,31 +82,23 @@
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
         elif '/.bzr/' in environ['PATH_INFO']:
-            # TODO: Use something here that uses the transport API 
-            # rather than relying on the local filesystem API.
-            try:
-                path = urlutils.local_path_from_url(self.transport.base)
-            except errors.InvalidURL:
-                raise httpexceptions.HTTPNotFound()
-            else:
-                app = urlparser.make_static(None, path)
-                return app(environ, start_response)
+            app = urlparser.make_static(None, self.folder)
+            return app(environ, start_response)
         else:
-            return BranchesFromTransportServer(
-                self.transport, self)(environ, start_response)
-
-
-class UserBranchesFromTransportRoot(object):
-
-    def __init__(self, transport, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
-        self._config = config
-        self.trunk_dir = config.get_option('trunk_dir')
+            return BranchesFromFileSystemServer(
+                self.folder, self)(environ, start_response)
+
+
+class UserBranchesFromFileSystemRoot(object):
+
+    def __init__(self, folder, trunk_dir):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
+        self.trunk_dir = trunk_dir
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info = environ['PATH_INFO']
+        path_info= environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'
@@ -117,10 +109,10 @@
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
-                new_transport = self.transport.clone(segment[1:])
-                return BranchesFromTransportServer(
-                    new_transport, self, segment)(environ, start_response)
+                new_path = os.path.join(self.folder, segment[1:])
+                return BranchesFromFileSystemServer(
+                    new_path, self, segment)(environ, start_response)
             else:
-                new_transport = self.transport.clone(self.trunk_dir)
-                return BranchesFromTransportServer(
-                    new_transport, self)(environ, start_response)
+                new_path = os.path.join(self.folder, self.trunk_dir)
+                return BranchesFromFileSystemServer(
+                    new_path, self)(environ, start_response)

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2009-05-02 14:01:05 +0000
+++ loggerhead/changecache.py	2009-03-19 21:01:11 +0000
@@ -27,10 +27,8 @@
 """
 
 import cPickle
-import marshal
 import os
 import tempfile
-import zlib
 
 try:
     from sqlite3 import dbapi2
@@ -40,26 +38,16 @@
 # We take an optimistic approach to concurrency here: we might do work twice
 # in the case of races, but not crash or corrupt data.
 
-def safe_init_db(filename, init_sql):
-    # To avoid races around creating the database, we create the db in
-    # a temporary file and rename it into the ultimate location.
-    fd, temp_path = tempfile.mkstemp(dir=os.path.dirname(filename))
-    os.close(fd)
-    con = dbapi2.connect(temp_path)
-    cur = con.cursor()
-    cur.execute(init_sql)
-    con.commit()
-    con.close()
-    os.rename(temp_path, filename)
-
 class FakeShelf(object):
 
     def __init__(self, filename):
         create_table = not os.path.exists(filename)
         if create_table:
-            safe_init_db(
-                filename, "create table RevisionData "
-                "(revid binary primary key, data binary)")
+            # To avoid races around creating the database, we create the db in
+            # a temporary file and rename it into the ultimate location.
+            fd, path = tempfile.mkstemp(dir=os.path.dirname(filename))
+            self._create_table(path)
+            os.rename(path, filename)
         self.connection = dbapi2.connect(filename)
         self.cursor = self.connection.cursor()
 
@@ -101,7 +89,8 @@
 
 class FileChangeCache(object):
 
-    def __init__(self, cache_path):
+    def __init__(self, history, cache_path):
+        self.history = history
 
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
@@ -115,44 +104,3 @@
             changes = self.history.get_file_changes_uncached(entry)
             cache.add(entry.revid, changes)
         return changes
-
-
-class RevInfoDiskCache(object):
-    """Like `RevInfoMemoryCache` but backed in a sqlite DB."""
-
-    def __init__(self, cache_path):
-        if not os.path.exists(cache_path):
-            os.mkdir(cache_path)
-        filename = os.path.join(cache_path, 'revinfo.sql')
-        create_table = not os.path.exists(filename)
-        if create_table:
-            safe_init_db(
-                filename, "create table Data "
-                "(key binary primary key, revid binary, data binary)")
-        self.connection = dbapi2.connect(filename)
-        self.cursor = self.connection.cursor()
-
-    def get(self, key, revid):
-        self.cursor.execute(
-            "select revid, data from data where key = ?", (dbapi2.Binary(key),))
-        row = self.cursor.fetchone()
-        if row is None:
-            return None
-        elif str(row[0]) != revid:
-            return None
-        else:
-            return marshal.loads(zlib.decompress(row[1]))
-
-    def set(self, key, revid, data):
-        try:
-            self.cursor.execute(
-                'delete from data where key = ?', (dbapi2.Binary(key), ))
-            blob = zlib.compress(marshal.dumps(data))
-            self.cursor.execute(
-                "insert into data (key, revid, data) values (?, ?, ?)",
-                map(dbapi2.Binary, [key, revid, blob]))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # don't care too much -- it's only a cache after all!
-            pass

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-05-18 05:16:38 +0000
+++ loggerhead/config.py	2009-03-31 21:43:03 +0000
@@ -4,22 +4,12 @@
 import tempfile
 
 
-_temporary_sql_dir = None
-
-def _get_temporary_sql_dir():
-    global _temporary_sql_dir
-    if _temporary_sql_dir is None:
-        _temporary_sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
-    return _temporary_sql_dir
-
 def command_line_parser():
     parser = OptionParser("%prog [options] <path>")
     parser.set_defaults(
         user_dirs=False,
         show_version=False,
         log_folder=None,
-        use_cdn=False,
-        sql_dir=None,
         )
     parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
                       help="Serve user directories as ~user.")
@@ -45,26 +35,17 @@
                       type=str, help="The directory to place log files in.")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
-    parser.add_option('--use-cdn', action='store_true',
-                      help="Serve YUI from Yahoo!'s CDN")
-    parser.add_option('--cache-dir', dest='sql_dir',
-                      help="The directory to place the SQL cache in")
     return parser
 
 
-class LoggerheadConfig(object):
+class LoggerheadConfig:
     '''A configuration object.'''
 
-    def __init__(self, argv=None):
-        if argv is None:
-            argv = sys.argv[1:]
+    def __init__(self):
         self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(argv)
+        self._options, self._args = self._parser.parse_args(sys.argv[1:])
 
-        sql_dir = self.get_option('sql_dir')
-        if sql_dir is None:
-            sql_dir = _get_temporary_sql_dir()
-        self.SQL_DIR = sql_dir
+        self.SQL_DIR = tempfile.mkdtemp(prefix='loggerhead-cache-')
 
     def get_option(self, option):
         '''Get an option from the options dict.'''
@@ -72,7 +53,7 @@
 
     def get_arg(self, index):
         '''Get an arg from the arg list.'''
-        return self._args[index]
+        return self._args(index)
 
     def print_help(self):
         '''Wrapper around OptionParser.print_help.'''

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-05-16 06:05:56 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-18 19:34:07 +0000
@@ -23,7 +23,6 @@
 
 import bzrlib.errors
 import bzrlib.textfile
-import bzrlib.osutils
 
 from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
@@ -49,17 +48,8 @@
 
         file_name = os.path.basename(self._history.get_path(revid, file_id))
 
-        file_text = tree.get_file_text(file_id)
-        encoding = 'utf-8'
-        try:
-            file_text = file_text.decode(encoding)
-        except UnicodeDecodeError:
-            encoding = 'iso-8859-15'
-            file_text = file_text.decode(encoding)
-
-        file_lines = bzrlib.osutils.split_lines(file_text)
-
-        try:
+        try:
+            file_lines = tree.get_file_lines(file_id)
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
                 # bail out; this isn't displayable text
@@ -68,7 +58,7 @@
                                      change=util.Container())
         else:
             if highlight is not None:
-                hl_lines = highlight(file_name, file_text, encoding)
+                hl_lines = highlight(file_name, ''.join(file_lines))
                 hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
                 hl_lines = map(cgi.escape, file_lines)

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-05-05 18:37:26 +0000
+++ loggerhead/controllers/directory_ui.py	2008-12-05 18:52:44 +0000
@@ -18,7 +18,7 @@
 
 import datetime
 import logging
-import stat
+import os
 
 from bzrlib import branch
 
@@ -48,7 +48,7 @@
 
     template_path = 'loggerhead.templates.directory'
 
-    def __init__(self, static_url_base, transport, name):
+    def __init__(self, static_url_base, path, name):
 
         class _branch(object):
             context_url = 1
@@ -58,23 +58,23 @@
                 return self._static_url_base + path
         self._branch = _branch
         self._history_callable = lambda:None
+        self._path = path
         self._name = name
         self._static_url_base = static_url_base
-        self.transport = transport
         self.log = logging.getLogger('')
 
     def get_values(self, path, kwargs, response):
-        listing = [d for d in self.transport.list_dir('.')
-                   if not d.startswith('.')]
+        listing = [d for d in os.listdir(self._path)
+                   if not d.startswith('.')
+                   and os.path.isdir(os.path.join(self._path, d))]
         listing.sort(key=lambda x: x.lower())
         dirs = []
         parity = 0
         for d in listing:
+            p = os.path.join(self._path, d)
             try:
-                b = branch.Branch.open_from_transport(self.transport.clone(d))
+                b = branch.Branch.open(p)
             except:
-                if not stat.S_ISDIR(self.transport.stat(d).st_mode):
-                    continue
                 b = None
             dirs.append(DirEntry(d, parity, b))
             parity = 1 - parity

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-04-29 19:55:16 +0000
+++ loggerhead/controllers/revision_ui.py	2009-03-19 19:04:40 +0000
@@ -95,18 +95,6 @@
 
         h.add_branch_nicks(change)
 
-        if '.' in change.revno:
-            # Walk "down" though the merge-sorted graph until we find a
-            # revision with merge depth 0: this is the revision that merged
-            # this one to mainline.
-            ri = self._history._rev_info
-            i = self._history._rev_indices[change.revid]
-            while ri[i][0][2] > 0:
-                i += 1
-            merged_in = ri[i][0][3]
-        else:
-            merged_in = None
-
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -128,7 +116,6 @@
             'filter_file_id': filter_file_id,
             'util': util,
             'history': h,
-            'merged_in': merged_in,
             'navigation': navigation,
             'query': query,
             'remember': remember,

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2009-05-16 06:03:47 +0000
+++ loggerhead/highlight.py	2009-03-06 13:19:38 +0000
@@ -24,13 +24,20 @@
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
 
-def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
+def highlight(path, text, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
+    encoding = 'utf-8'
+    try:
+        text = text.decode(encoding)
+    except UnicodeDecodeError:
+        encoding = 'iso-8859-15'
+        text = text.decode(encoding)
+
     try:
         lexer = guess_lexer_for_filename(path, text[:1024], encoding=encoding)
     except (ClassNotFound, ValueError):

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-05-18 04:17:11 +0000
+++ loggerhead/history.py	2009-03-19 20:04:24 +0000
@@ -34,6 +34,9 @@
 import re
 import textwrap
 import threading
+import time
+import urllib
+from StringIO import StringIO
 
 from loggerhead import search
 from loggerhead import util
@@ -44,7 +47,6 @@
 import bzrlib.delta
 import bzrlib.diff
 import bzrlib.errors
-import bzrlib.lru_cache
 import bzrlib.progress
 import bzrlib.revision
 import bzrlib.textfile
@@ -175,43 +177,6 @@
                 file_id=file_id))
 
 
-class RevInfoMemoryCache(object):
-    """A store that validates values against the revids they were stored with.
-
-    We use a unique key for each branch.
-
-    The reason for not just using the revid as the key is so that when a new
-    value is provided for a branch, we replace the old value used for the
-    branch.
-
-    There is another implementation of the same interface in
-    loggerhead.changecache.RevInfoDiskCache.
-    """
-
-    def __init__(self, cache):
-        self._cache = cache
-
-    def get(self, key, revid):
-        """Return the data associated with `key`, subject to a revid check.
-
-        If a value was stored under `key`, with the same revid, return it.
-        Otherwise return None.
-        """
-        cached = self._cache.get(key)
-        if cached is None:
-            return None
-        stored_revid, data = cached
-        if revid == stored_revid:
-            return data
-        else:
-            return None
-
-    def set(self, key, revid, data):
-        """Store `data` under `key`, to be checked against `revid` on get().
-        """
-        self._cache[key] = (revid, data)
-
-
 class History (object):
     """Decorate a branch to provide information for rendering.
 
@@ -220,69 +185,13 @@
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
 
-    :ivar _file_change_cache: An object that caches information about the
-        files that changed between two revisions.
-    :ivar _rev_info: A list of information about revisions.  This is by far
-        the most cryptic data structure in loggerhead.  At the top level, it
-        is a list of 3-tuples [(merge-info, where-merged, parents)].
-        `merge-info` is (seq, revid, merge_depth, revno_str, end_of_merge) --
-        like a merged sorted list, but the revno is stringified.
-        `where-merged` is a tuple of revisions that have this revision as a
-        non-lefthand parent.  Finally, `parents` is just the usual list of
-        parents of this revision.
-    :ivar _rev_indices: A dictionary mapping each revision id to the index of
-        the information about it in _rev_info.
-    :ivar _revno_revid: A dictionary mapping stringified revnos to revision
-        ids.
+    :ivar _file_change_cache: xx
     """
 
-    def _load_whole_history_data(self, caches, cache_key):
-        """Set the attributes relating to the whole history of the branch.
-
-        :param caches: a list of caches with interfaces like
-            `RevInfoMemoryCache` and be ordered from fastest to slowest.
-        :param cache_key: the key to use with the caches.
-        """
-        self._rev_indices = None
-        self._rev_info = None
-
-        missed_caches = []
-        def update_missed_caches():
-            for cache in missed_caches:
-                cache.set(cache_key, self.last_revid, self._rev_info)
-        for cache in caches:
-            data = cache.get(cache_key, self.last_revid)
-            if data is not None:
-                self._rev_info = data
-                update_missed_caches()
-                break
-            else:
-                missed_caches.append(cache)
-        else:
-            whole_history_data = compute_whole_history_data(self._branch)
-            self._rev_info, self._rev_indices = whole_history_data
-            update_missed_caches()
-
-        if self._rev_indices is not None:
-            self._revno_revid = {}
-            for ((_, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._revno_revid[revno_str] = revid
-        else:
-            self._revno_revid = {}
-            self._rev_indices = {}
-            for ((seq, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._rev_indices[revid] = seq
-                self._revno_revid[revno_str] = revid
-
-    def __init__(self, branch, whole_history_data_cache, file_cache=None,
-                 revinfo_disk_cache=None, cache_key=None):
+    def __init__(self, branch, whole_history_data_cache):
         assert branch.is_locked(), (
             "Can only construct a History object with a read-locked branch.")
-        if file_cache is not None:
-            self._file_change_cache = file_cache
-            file_cache.history = self
-        else:
-            self._file_change_cache = None
+        self._file_change_cache = None
         self._branch = branch
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
@@ -290,10 +199,17 @@
 
         self.last_revid = branch.last_revision()
 
-        caches = [RevInfoMemoryCache(whole_history_data_cache)]
-        if revinfo_disk_cache:
-            caches.append(revinfo_disk_cache)
-        self._load_whole_history_data(caches, cache_key)
+        whole_history_data = whole_history_data_cache.get(self.last_revid)
+        if whole_history_data is None:
+            whole_history_data = compute_whole_history_data(branch)
+            whole_history_data_cache[self.last_revid] = whole_history_data
+
+        (self._revision_graph, self._full_history, self._revision_info,
+         self._revno_revid, self._merge_sort, self._where_merged,
+         ) = whole_history_data
+
+    def use_file_cache(self, cache):
+        self._file_change_cache = cache
 
     @property
     def has_revisions(self):
@@ -303,12 +219,12 @@
         return self._branch.get_config()
 
     def get_revno(self, revid):
-        if revid not in self._rev_indices:
+        if revid not in self._revision_info:
             # ghost parent?
             return 'unknown'
-        seq = self._rev_indices[revid]
-        revno = self._rev_info[seq][0][3]
-        return revno
+        (seq, revid, merge_depth,
+         revno_str, end_of_merge) = self._revision_info[revid]
+        return revno_str
 
     def get_revids_from(self, revid_list, start_revid):
         """
@@ -316,17 +232,16 @@
         revid in revid_list.
         """
         if revid_list is None:
-            revid_list = [r[0][1] for r in self._rev_info]
+            revid_list = self._full_history
         revid_set = set(revid_list)
         revid = start_revid
 
         def introduced_revisions(revid):
             r = set([revid])
-            seq = self._rev_indices[revid]
-            md = self._rev_info[seq][0][2]
+            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
             i = seq + 1
-            while i < len(self._rev_info) and self._rev_info[i][0][2] > md:
-                r.add(self._rev_info[i][0][1])
+            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
+                r.add(self._merge_sort[i][1])
                 i += 1
             return r
         while 1:
@@ -334,7 +249,7 @@
                 return
             if introduced_revisions(revid) & revid_set:
                 yield revid
-            parents = self._rev_info[self._rev_indices[revid]][2]
+            parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
             revid = parents[0]
@@ -348,9 +263,9 @@
             w = self._branch.repository.weave_store.get_weave(
                     file_id, self._branch.repository.get_transaction())
             w_revids = w.versions()
-            revids = [r for r in self._rev_indices if r in w_revids]
+            revids = [r for r in self._full_history if r in w_revids]
         except AttributeError:
-            possible_keys = [(file_id, revid) for revid in self._rev_indices]
+            possible_keys = [(file_id, revid) for revid in self._full_history]
             get_parent_map = self._branch.repository.texts.get_parent_map
             # We chunk the requests as this works better with GraphIndex.
             # See _filter_revisions_touching_file_id in bzrlib/log.py
@@ -551,10 +466,10 @@
 
         merge_point = []
         while True:
-            children = self._rev_info[self._rev_indices[revid]][1]
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
-                child_parents = self._rev_info[self._rev_indices[child]][2]
+                child_parents = self._revision_graph[child]
                 if child_parents[0] == revid:
                     nexts.append(child)
                 else:

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-04-01 22:50:25 +0000
+++ loggerhead/middleware/profile.py	2009-03-30 22:05:16 +0000
@@ -35,3 +35,75 @@
             self.lock.release()
 
 
+class MemoryProfileMiddleware(object):
+    '''Paste middleware for profiling memory with heapy.'''
+
+    def __init__(self, app, limit=40):
+        self.app = app
+        self.lock = threading.Lock()
+
+        self.type2count = {}
+        self.type2all = {}
+        self.limit = limit
+
+    def update(self):
+        try:
+            obs = sys.getobjects(0)
+        except AttributeError:
+            logging.error(
+                'Python does not have debug symbols compiled.  Memory will '
+                'not be profiled.')
+            return
+        type2count = {}
+        type2all = {}
+        for o in obs:
+            all = sys.getrefcount(o)
+
+            if type(o) is str and o == '<dummy key>':
+                # avoid dictionary madness
+                continue
+            t = type(o)
+            if t in type2count:
+                type2count[t] += 1
+                type2all[t] += all
+            else:
+                type2count[t] = 1
+                type2all[t] = all
+
+        ct = [(type2count[t] - self.type2count.get(t, 0),
+               type2all[t] - self.type2all.get(t, 0),
+               t)
+              for t in type2count.iterkeys()]
+        ct.sort()
+        ct.reverse()
+        printed = False
+
+        logger = logging.getLogger('loggerhead-memprofile')
+        logger.debug('*' * 20)
+        logger.debug("Loggerhead Memory Profiling")
+        i = 0
+        for delta1, delta2, t in ct:
+            if delta1 or delta2:
+                if not printed:
+                    logger.debug("%-55s %8s %8s" % ('', 'insts', 'refs'))
+                    printed = True
+
+                logger.debug("%-55s %8d %8d" % (t, delta1, delta2))
+
+                i += 1
+                if i >= self.limit:
+                    break
+
+        self.type2count = type2count
+        self.type2all = type2all
+
+    def __call__(self, environ, start_response):
+        self.lock.acquire()
+        try:
+            # We don't want to be working with the static images
+            # TODO: There needs to be a better way to do this.
+            self.update()
+            return self.app(environ, start_response)
+        finally:
+            self.lock.release()
+

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 01:50:05 +0000
+++ loggerhead/search.py	2008-11-05 00:50:06 +0000
@@ -17,17 +17,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-_mod_index = None
-def import_search():
-    global errors, _mod_index, FileTextHit, RevisionHit
-    if _mod_index is not None:
-        return
-    try:
-        from bzrlib.plugins.search import errors
-        from bzrlib.plugins.search import index as _mod_index
-        from bzrlib.plugins.search.index import FileTextHit, RevisionHit
-    except ImportError:
-        _mod_index = None
+import sets
+try:
+    from bzrlib.plugins.search import errors
+    from bzrlib.plugins.search import index as _mod_index
+    from bzrlib.plugins.search.index import FileTextHit, RevisionHit
+except ImportError:
+    _mod_index = None
 
 
 def search_revisions(branch, query_list, suggest=False):
@@ -40,7 +36,6 @@
     param suggest: Optional flag to request suggestions instead of results
     return: A list for results, either revision ids or terms
     """
-    import_search()
     if _mod_index is None:
         return None # None indicates could-not-search
     try:
@@ -64,6 +59,6 @@
                     revid_list.append(result.text_key[1])
                 elif isinstance(result, RevisionHit):
                     revid_list.append(result.revision_key[0])
-            return list(set(revid_list))
+            return list(sets.Set(revid_list))
     finally:
         index._branch.unlock()

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
+++ loggerhead/static/javascript/custom.js	2009-03-31 21:20:06 +0000
@@ -1,4 +1,6 @@
-Y = YUI().use("node", "io-base", "anim");
+Y = YUI().use("node", "io-base", "io-queue", "anim");
+
+Y.io.queue.size(2);
 
 var global_timeout_id = null;
 var global_search_request = null;
@@ -122,9 +124,7 @@
 
 Collapsable.prototype._load_finished = function(tid, res, args)
 {
-  var l = res.responseText.split('\n');
-  l.splice(0, 1);
-  var newNode = Y.Node.create(l.join(''));
+  var newNode = Y.Node.create(res.responseText.split('\n').splice(1).join(''));
   if (this.node_process)
     this.node_process(newNode);
   this.source = null;
@@ -140,7 +140,7 @@
 Collapsable.prototype._ensure_container = function(callback)
 {
   if (this.container == null) {
-    this.container = Y.Node.create('<div></div>');
+    this.container = Y.Node.create('<div style="overflow:hidden;"></div>');
     if (this.closed_node) {
       this.closed_node.ancestor().replaceChild(
         this.container, this.closed_node);
@@ -154,9 +154,6 @@
         this.container, this.open_node);
       this.container.appendChild(this.open_node);
     }
-    var outer = Y.Node.create('<div style="overflow:hidden;"></div>');
-    this.container.ancestor().replaceChild(outer, this.container);
-    outer.appendChild(this.container);
   }
 }
 
@@ -209,7 +206,7 @@
   this._animate(callback);
 
   if (this.source) {
-    Y.io(
+    Y.io.queue(
       this.source,
       {
         on: {complete: this._load_finished},

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-04-28 03:01:54 +0000
+++ loggerhead/templatefunctions.py	2009-03-19 00:18:46 +0000
@@ -57,12 +57,12 @@
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None, merged_in=None):
+def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
         file_changes=file_changes, currently_showing=currently_showing,
-        merged_in=merged_in, **templatefunctions)
+        **templatefunctions)
 
 
 @templatefunc

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
+++ loggerhead/templates/browse.pt	2008-10-18 00:23:09 +0000
@@ -43,12 +43,12 @@
                   </a>
                 </td>
               </tr>
-              <tr tal:condition="view/served_url">
+              <tr tal:condition="view/branch_url">
                 <td class="name">
                 </td>
                 <td class="description url" colspan="2">
-                  <a tal:attributes="href view/served_url"
-                     tal:content="view/served_url" />
+                  <a tal:attributes="href view/branch_url"
+                     tal:content="view/branch_url" />
                 </td>
               </tr>
             </tal:block>

=== modified file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	2009-03-17 00:02:21 +0000
@@ -1,4 +1,4 @@
-<div>
+<div class="diffinfo">
   <div class="pseudotable unified"
        tal:repeat="chunk chunks">
 

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
+++ loggerhead/templates/macros.pt	2009-03-31 19:28:09 +0000
@@ -17,23 +17,35 @@
       var expanded_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeExpanded.png')+'\''" />;
     </script>
     <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('yui/yui-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('oop/oop-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('event/event-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('attribute/attribute-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('base/base-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('dom/dom-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('node/node-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('anim/anim-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('io/io-base-min.js')"></script>
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/yui/yui-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/oop/oop-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/event/event-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/attribute/attribute-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/base/base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/dom/dom-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/node/node-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/anim/anim-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-queue-min.js')"></script>
     <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-04-28 03:01:54 +0000
+++ loggerhead/templates/revision.pt	2009-03-31 21:15:48 +0000
@@ -96,7 +96,7 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path, merged_in)" />
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path)" />
         <tal:specific-path condition="not:specific_path">
           <p class="expand show_if_js" id="expand_all"><a href="#">
               <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-04-28 03:01:54 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-03-19 00:18:46 +0000
@@ -12,11 +12,6 @@
                                href python:url(['/revision', merge_point.revno], clear=1)"
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
-        <div class="mto" tal:condition="merged_in">
-          This revision was merged to the branch mainline in
-          <a tal:attributes="href python:url(['/revision', merged_in], clear=1)">revision
-            <tal:b content="merged_in"/></a>.
-        </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-04-02 20:32:12 +0000
+++ loggerhead/tests/test_corners.py	2009-03-16 18:54:39 +0000
@@ -34,16 +34,6 @@
         res = app.get('/revision/'+newrevid)
         res.mustcontain('executable')
 
-    def test_revision_escapes_commit_message(self):
-        """XXX."""
-        self.createBranch()
-
-        msg = '<b>hi</b>'
-        self.addFileAndCommit('myfilename', msg)
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        self.assertFalse(msg in res.body)
-
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
         self.createBranch()

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-04-02 20:32:12 +0000
+++ loggerhead/util.py	2009-03-19 20:31:49 +0000
@@ -250,7 +250,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-05-18 04:17:11 +0000
+++ loggerhead/wholehistory.py	2008-12-05 20:09:14 +0000
@@ -37,10 +37,6 @@
 
 
 def compute_whole_history_data(branch):
-    """Compute _rev_info and _rev_indices for a branch.
-
-    See History.__doc__ for what these data structures mean.
-    """
     z = time.time()
 
     last_revid = branch.last_revision()
@@ -53,31 +49,31 @@
          graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
-
-    _rev_info = []
-    _rev_indices = {}
-
+    _full_history = []
+    _revision_info = {}
+    _revno_revid = {}
     if is_null(last_revid):
         _merge_sort = []
     else:
         _merge_sort = merge_sort(
             _revision_graph, last_revid, generate_revno=True)
 
-    for info in _merge_sort:
-        seq, revid, merge_depth, revno, end_of_merge = info
+    for (seq, revid, merge_depth, revno, end_of_merge) in _merge_sort:
+        _full_history.append(revid)
         revno_str = '.'.join(str(n) for n in revno)
-        parents = _revision_graph[revid]
-        _rev_indices[revid] = len(_rev_info)
-        _rev_info.append([(seq, revid, merge_depth, revno_str, end_of_merge), (), parents])
+        _revno_revid[revno_str] = revid
+        _revision_info[revid] = (
+            seq, revid, merge_depth, revno_str, end_of_merge)
+
+    _where_merged = {}
 
     for revid in _revision_graph.keys():
-        if _rev_info[_rev_indices[revid]][0][2] == 0:
+        if _revision_info[revid][2] == 0:
             continue
         for parent in _revision_graph[revid]:
-            c = _rev_info[_rev_indices[parent]]
-            if revid not in c[1]:
-                c[1] = c[1] + (revid,)
+            _where_merged.setdefault(parent, set()).add(revid)
 
     log.info('built revision graph cache: %r secs' % (time.time() - z))
 
-    return (_rev_info, _rev_indices)
+    return (_revision_graph, _full_history, _revision_info,
+            _revno_revid, _merge_sort, _where_merged)

=== modified file 'serve-branches'
--- serve-branches	2009-05-04 20:21:08 +0000
+++ serve-branches	2009-03-31 21:47:14 +0000
@@ -20,15 +20,14 @@
 import sys
 
 from bzrlib.plugin import load_plugins
-from bzrlib.transport import get_transport
 
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler, HTTPInternalServerError
 from paste.translogger import TransLogger
 
 from loggerhead import __version__
-from loggerhead.apps.transport import (
-    BranchesFromTransportRoot, UserBranchesFromTransportRoot)
+from loggerhead.apps.filesystem import (
+    BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
 from loggerhead.config import LoggerheadConfig
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
@@ -45,13 +44,13 @@
         config.print_help()
         sys.exit(1)
     elif config.arg_count == 1:
-        path = config.get_arg(0)
+        [path] = args
     else:
         path = '.'
 
-    load_plugins()
-
-    transport = get_transport(path)
+    if not os.path.isdir(path):
+        print "%s is not a directory" % path
+        sys.exit(1)
 
     if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
         print "--trunk-dir is only valid with --user-dirs"
@@ -64,12 +63,13 @@
             return Reloader.restart_with_reloader()
 
     if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
+        if not config.get_option['trunk_dir']:
             print "You didn't specify a directory for the trunk directories."
             sys.exit(1)
-        app = UserBranchesFromTransportRoot(transport, config)
+        app = UserBranchesFromFileSystemRoot(
+            path, config.get_option('trunk_dir'))
     else:
-        app = BranchesFromTransportRoot(transport, config)
+        app = BranchesFromFileSystemRoot(path)
 
     # setup_logging()
     logging.basicConfig()
@@ -77,7 +77,7 @@
     logger = getattr(app, 'log', logging.getLogger('loggerhead'))
     if config.get_option('log_folder'):
         logfile_path = os.path.join(
-            config.get_option('log_folder'), 'serve-branches.log')
+            config.get_option['log_folder'], 'serve-branches.log')
     else:
         logfile_path = 'serve-branches.log'
     logfile = logging.FileHandler(logfile_path, 'a')
@@ -87,6 +87,11 @@
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
 
+    if config.get_option('memory_profile'):
+        memprofile = logging.getLogger('loggerhead-memprofile')
+        memprofile.setLevel(logging.DEBUG)
+        memprofile.addHandler(logging.FileHandler('loggerhead-memprofile'))
+
     # setup_logging() #end
 
     app = TransLogger(app, logger=logger)
@@ -94,8 +99,8 @@
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
     if config.get_option('memory_profile'):
-        from dozer import Dozer
-        app = Dozer(app)
+        from loggerhead.middleware.profile import MemoryProfileMiddleware
+        app = MemoryProfileMiddleware(app)
 
     if not config.get_option('user_prefix'):
         prefix = '/'
@@ -135,6 +140,8 @@
     else:
         host = config.get_option('user_host')
 
+    load_plugins()
+
     httpserver.serve(app, host=host, port=port)
 
 

